from tabulate import tabulate
import pandas as pd


def quater_summary_format(df):
    df = add_year_agg_to_qtr_index(df)
    df = df.T
    res = tabulate(df, tablefmt='html', floatfmt=".2f", headers=df.columns)
    return res


def add_year_agg_to_qtr_index(df):
    """
    Given a dataframe of PeriodIndex('Q') add Yearly averages and return
    with yearly avg inserted into the appropriate rows
    :param df:
    :return:
    """

    y = df.groupby(pd.Grouper(freq='Y')).mean() # average the qtrs
    dfs = []
    for x, year in y.iterrows():
        d = df.loc[str(year.name)]
        d = pd.concat([d, pd.DataFrame(year).T])
        dfs.append(d)

    res = pd.concat(dfs)
    return res
